#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "metals.inc"
#include "glass.inc"
#include "ynkelonium_texture.pov"
#include "T_BlackMetal.pov"
#include "Triebwerk.pov"

#declare Zylinder = 
    union {
	cone {
	    <0,-750,0>, 750
	    <0,750,0>, 750
	}
	difference {
	    cone {
		<0,750,0>, 750
		<0,870,0>, 630
	    }
	    sphere {
		<0, 1250+750, 0> 1250
	    }
	}
	difference {
	    cone {
		<0,-750,0>, 750
		<0,-870,0>, 630
	    }
	    sphere {
		<0, -(1250+750), 0> 1250
	    }
	}
	texture {
	    Ynkelonium_Texture
	}
    }

#declare Ringwulst = 
    union {
	difference {
	    torus {
		750, 400
	    }
	    #declare i = 0
	    #while (i < 360) 
		object {
		    Triebwerk_neg
		    rotate <0, 0, 45>
		    translate <750, 0, 0>
		    rotate <0, i, 0>
		}
		object {
		    Triebwerk_neg
		    rotate <0, 0, -45>
		    translate <750, 0, 0>
		    rotate <0, i, 0>
		}
		#declare i = i + 30
	    #end
	}

	texture {
	    Ynkelonium_Texture
	}

    }


#declare Mittelstueck = 
union {
    object {
	Zylinder
    }
    object {
	Ringwulst
    }
}

